﻿var AutoIsbn = (function (_super) {
    __extends(AutoIsbn, _super);
    function AutoIsbn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }

    AutoIsbn.prototype.execute = function () {
        // Get isbn settings
        var commandSettings = this.CommandParam;
        var isbnCell = commandSettings.IsbnCell;
        var isbnCellLocation = this.getCellLocation(isbnCell);
        var isbnvalue = this.evaluateFormula(isbnCell);

        //other settings
        var titleCell = commandSettings.TitleCell;
        var titleCellLocation = this.getCellLocation(titleCell);

        var authorCell = commandSettings.AuthorCell;
        var authorCellLocation = this.getCellLocation(authorCell);

        var pagesCell = commandSettings.PagesCell;
        var pagesCellLocation = this.getCellLocation(pagesCell) || '';

        var pubdateCell = commandSettings.PubdateCell;
        var pubdateCellLocation = this.getCellLocation(pubdateCell);

        var publishCell = commandSettings.PublishCell;
        var publishCellLocation = this.getCellLocation(publishCell);

        var translatorCell = commandSettings.TranslatorCell;
        var translatorCellLocation = this.getCellLocation(translatorCell);

        var bindingCell = commandSettings.BindingCell;
        var bindingCellLocation = this.getCellLocation(bindingCell);

        var priceCell = commandSettings.PriceCell;
        var priceCellLocation = this.getCellLocation(priceCell);

        var picCell = commandSettings.PicCell;
        var picCellLocation = this.getCellLocation(picCell);

        var AbstractCell = commandSettings.AbstractCell;
        var abstractCellLocation = this.getCellLocation(AbstractCell);

        var Book_introCell = commandSettings.Book_introCell;
        var book_introCellLocation = this.getCellLocation(Book_introCell);

        var Author_introCell = commandSettings.Author_introCell;
        var author_introCelLocation = this.getCellLocation(Author_introCell);

        var doubanScore_introCell = commandSettings.doubanScore_introCell;
        var doubanScore_introCellLocation = this.getCellLocation(doubanScore_introCell);
        // get

        $.ajax({
            type: "GET",
            url: "customapi/http/get",
            data:{
                url: "https://api.zuk.pw/situ/book/isbn/" + isbnvalue
            },
            async: true,
            success: function (result) {
                
                //var obj = JSON.parse(result) || {};
                var obj = result;
                
                if (obj.msg == '请求成功') {
                    //setValue
                    Forguncy.Page.getCellByLocation(titleCellLocation).setValue(obj.data.name);
                    Forguncy.Page.getCellByLocation(authorCellLocation).setValue(obj.data.author);

                    Forguncy.Page.getCellByLocation(pagesCellLocation).setValue(obj.data.pages);
                    Forguncy.Page.getCellByLocation(pubdateCellLocation).setValue(obj.data.published);
                    Forguncy.Page.getCellByLocation(publishCellLocation).setValue(obj.data.publishing);
                    Forguncy.Page.getCellByLocation(translatorCellLocation).setValue(obj.data.translator);
                    Forguncy.Page.getCellByLocation(bindingCellLocation).setValue(obj.data.designed);
                    Forguncy.Page.getCellByLocation(priceCellLocation).setValue(obj.data.price);

                    //获取图片单元格id
                    //var CellID = "r" + picCellLocation.Row + "c" + picCellLocation.Column + "p";
                    //处理图片地址
                    //document.getElementById(CellID).style.backgroundImage = "url(" + "https://images.weserv.nl/?url=" + obj.cover_url + ")";
                    Forguncy.Page.getCellByLocation(picCellLocation).setValue("https://images.weserv.nl/?url=" + obj.data.photoUrl);
                    Forguncy.Page.getCellByLocation(abstractCellLocation).setValue(obj.data.subname);
                    Forguncy.Page.getCellByLocation(book_introCellLocation).setValue(obj.data.description);
                    Forguncy.Page.getCellByLocation(author_introCelLocation).setValue(obj.data.authorIntro);
                    Forguncy.Page.getCellByLocation(doubanScore_introCellLocation).setValue(obj.data.doubanScore / 10);
                } else {
                    //提示错误
                    //if (typeof (obj.error) !== 'undefined') {
                    console.log(obj.msg);
                }
                
            }
        });
	}
    return AutoIsbn;
}(Forguncy.CommandBase));

// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.CommandFactory.registerCommand("AutoIsbn.AutoIsbn, AutoIsbn", AutoIsbn);